<h1 align="center">ToDo App</h1>
  
<p align="center">  
Task Management App based on Modern Android Application tech-stacks and MVVM architecture.
<br>
</p>
<br>

<p align="center">
<img src="https://user-images.githubusercontent.com/65807152/143182039-50aeacc2-b162-4027-9d6f-fa6728a4ed0e.png" width=700>
</p>

<img src="https://user-images.githubusercontent.com/65807152/143182201-a9179797-359a-4f7f-880c-7fe8082a9f0c.gif" align="right" width="30%"/>

## Techs Used 💻
- [Kotlin](https://kotlinlang.org/) - First class and official programming language for Android development.
- [Coroutines](https://kotlinlang.org/docs/coroutines-overview.html) - For Asynchronous.
- [Flow](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines.flow/-flow/) - A cold asynchronous data stream that sequentially emits values and completes normally or with an exception.
- [StateFlow](https://developer.android.com/kotlin/flow/stateflow-and-sharedflow) - StateFlow is a state-holder observable flow that emits the current and new state updates to its collectors.
- [Android Architecture Components](https://developer.android.com/topic/architecture) - Collection of libraries that help you design robust, testable, and maintainable apps.
  - [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel) - Stores UI-related data that isn't destroyed on UI changes.
  - [ViewBinding](https://developer.android.com/topic/libraries/view-binding) - Generates a binding class for each XML layout file present in that module and allows you to more easily write code that interacts with views.
  - [Room Database](https://developer.android.com/training/data-storage/room) - Room is an android library which is an ORM which wraps android's native SQLite database.
- [Dagger-Hilt](https://dagger.dev/hilt/) - Standard library to incorporate Dagger dependency injection into an Android application.

## Application Install
You can Install and test the app from below 👇

[![Todo App](https://img.shields.io/badge/ToDo_App-APK-silver.svg?style=for-the-badge&logo=android)](https://github.com/Rohit-2602/To-Do-App/releases/tag/release)

## Find this repository useful? ❤️
Support it by joining [stargazers](https://github.com/Rohit-2602/To-Do-App/stargazers) for this repository. ⭐
And [follow](https://github.com/Rohit-2602) me for my next creations! 🤩


# License
```xml
Designed and developed by 2021 Rohit-2602 (Rohit Sharma)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
```

